Index: /stable/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorClassification.cs
===================================================================
--- /stable/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorClassification.cs	(revision 11906)
+++ /stable/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorClassification.cs	(revision 11907)
@@ -142,6 +142,11 @@
 
     public static SupportVectorClassificationSolution CreateSupportVectorClassificationSolution(IClassificationProblemData problemData, IEnumerable<string> allowedInputVariables,
-      string svmType, string kernelType, double cost, double nu, double gamma, int degree,
-      out double trainingAccuracy, out double testAccuracy, out int nSv) {
+      string svmType, string kernelType, double cost, double nu, double gamma, int degree, out double trainingAccuracy, out double testAccuracy, out int nSv) {
+      return CreateSupportVectorClassificationSolution(problemData, allowedInputVariables, GetSvmType(svmType), GetKernelType(kernelType), cost, nu, gamma, degree,
+        out trainingAccuracy, out testAccuracy, out nSv);
+    }
+
+    public static SupportVectorClassificationSolution CreateSupportVectorClassificationSolution(IClassificationProblemData problemData, IEnumerable<string> allowedInputVariables,
+      int svmType, int kernelType, double cost, double nu, double gamma, int degree, out double trainingAccuracy, out double testAccuracy, out int nSv) {
       Dataset dataset = problemData.Dataset;
       string targetVariable = problemData.TargetVariable;
@@ -150,6 +155,6 @@
       //extract SVM parameters from scope and set them
       svm_parameter parameter = new svm_parameter();
-      parameter.svm_type = GetSvmType(svmType);
-      parameter.kernel_type = GetKernelType(kernelType);
+      parameter.svm_type = svmType;
+      parameter.kernel_type = kernelType;
       parameter.C = cost;
       parameter.nu = nu;
@@ -161,5 +166,4 @@
       parameter.shrinking = 1;
       parameter.coef0 = 0;
-
 
       var weightLabels = new List<int>();
Index: /stable/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorMachineUtil.cs
===================================================================
--- /stable/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorMachineUtil.cs	(revision 11906)
+++ /stable/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorMachineUtil.cs	(revision 11907)
@@ -20,7 +20,14 @@
 #endregion
 
+using System;
 using System.Collections.Generic;
 using System.Linq;
+using System.Linq.Expressions;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Random;
 using LibSVM;
 
@@ -34,14 +41,11 @@
     /// <returns>A problem data type that can be used to train a support vector machine.</returns>
     public static svm_problem CreateSvmProblem(Dataset dataset, string targetVariable, IEnumerable<string> inputVariables, IEnumerable<int> rowIndices) {
-      double[] targetVector =
-        dataset.GetDoubleValues(targetVariable, rowIndices).ToArray();
-
+      double[] targetVector = dataset.GetDoubleValues(targetVariable, rowIndices).ToArray();
       svm_node[][] nodes = new svm_node[targetVector.Length][];
-      List<svm_node> tempRow;
       int maxNodeIndex = 0;
       int svmProblemRowIndex = 0;
       List<string> inputVariablesList = inputVariables.ToList();
       foreach (int row in rowIndices) {
-        tempRow = new List<svm_node>();
+        List<svm_node> tempRow = new List<svm_node>();
         int colIndex = 1; // make sure the smallest node index for SVM = 1
         foreach (var inputVariable in inputVariablesList) {
@@ -50,5 +54,6 @@
           // => don't add NaN values in the dataset to the sparse SVM matrix representation
           if (!double.IsNaN(value)) {
-            tempRow.Add(new svm_node() { index = colIndex, value = value }); // nodes must be sorted in ascending ordered by column index
+            tempRow.Add(new svm_node() { index = colIndex, value = value });
+            // nodes must be sorted in ascending ordered by column index
             if (colIndex > maxNodeIndex) maxNodeIndex = colIndex;
           }
@@ -57,6 +62,168 @@
         nodes[svmProblemRowIndex++] = tempRow.ToArray();
       }
-
-      return new svm_problem() { l = targetVector.Length, y = targetVector, x = nodes };
+      return new svm_problem { l = targetVector.Length, y = targetVector, x = nodes };
+    }
+
+    /// <summary>
+    /// Instantiate and return a svm_parameter object with default values.
+    /// </summary>
+    /// <returns>A svm_parameter object with default values</returns>
+    public static svm_parameter DefaultParameters() {
+      svm_parameter parameter = new svm_parameter();
+      parameter.svm_type = svm_parameter.NU_SVR;
+      parameter.kernel_type = svm_parameter.RBF;
+      parameter.C = 1;
+      parameter.nu = 0.5;
+      parameter.gamma = 1;
+      parameter.p = 1;
+      parameter.cache_size = 500;
+      parameter.probability = 0;
+      parameter.eps = 0.001;
+      parameter.degree = 3;
+      parameter.shrinking = 1;
+      parameter.coef0 = 0;
+
+      return parameter;
+    }
+
+    public static double CrossValidate(IDataAnalysisProblemData problemData, svm_parameter parameters, int numberOfFolds, bool shuffleFolds = true) {
+      var partitions = GenerateSvmPartitions(problemData, numberOfFolds, shuffleFolds);
+      return CalculateCrossValidationPartitions(partitions, parameters);
+    }
+
+    public static svm_parameter GridSearch(out double cvMse, IDataAnalysisProblemData problemData, Dictionary<string, IEnumerable<double>> parameterRanges, int numberOfFolds, bool shuffleFolds = true, int maxDegreeOfParallelism = 1) {
+      DoubleValue mse = new DoubleValue(Double.MaxValue);
+      var bestParam = DefaultParameters();
+      var crossProduct = parameterRanges.Values.CartesianProduct();
+      var setters = parameterRanges.Keys.Select(GenerateSetter).ToList();
+      var partitions = GenerateSvmPartitions(problemData, numberOfFolds, shuffleFolds);
+
+      var locker = new object(); // for thread synchronization
+      Parallel.ForEach(crossProduct, new ParallelOptions { MaxDegreeOfParallelism = maxDegreeOfParallelism },
+      parameterCombination => {
+        var parameters = DefaultParameters();
+        var parameterValues = parameterCombination.ToList();
+        for (int i = 0; i < parameterValues.Count; ++i)
+          setters[i](parameters, parameterValues[i]);
+
+        double testMse = CalculateCrossValidationPartitions(partitions, parameters);
+        if (!double.IsNaN(testMse)) {
+          lock (locker) {
+            if (testMse < mse.Value) {
+              mse.Value = testMse;
+              bestParam = (svm_parameter)parameters.Clone();
+            }
+          }
+        }
+      });
+      cvMse = mse.Value;
+      return bestParam;
+    }
+
+    private static double CalculateCrossValidationPartitions(Tuple<svm_problem, svm_problem>[] partitions, svm_parameter parameters) {
+      double avgTestMse = 0;
+      var calc = new OnlineMeanSquaredErrorCalculator();
+      foreach (Tuple<svm_problem, svm_problem> tuple in partitions) {
+        var trainingSvmProblem = tuple.Item1;
+        var testSvmProblem = tuple.Item2;
+        var model = svm.svm_train(trainingSvmProblem, parameters);
+        calc.Reset();
+        for (int i = 0; i < testSvmProblem.l; ++i)
+          calc.Add(testSvmProblem.y[i], svm.svm_predict(model, testSvmProblem.x[i]));
+        double mse = calc.ErrorState == OnlineCalculatorError.None ? calc.MeanSquaredError : double.NaN;
+        avgTestMse += mse;
+      }
+      avgTestMse /= partitions.Length;
+      return avgTestMse;
+    }
+
+    private static Tuple<svm_problem, svm_problem>[] GenerateSvmPartitions(IDataAnalysisProblemData problemData, int numberOfFolds, bool shuffleFolds = true) {
+      var folds = GenerateFolds(problemData, numberOfFolds, shuffleFolds).ToList();
+      var targetVariable = GetTargetVariableName(problemData);
+      var partitions = new Tuple<svm_problem, svm_problem>[numberOfFolds];
+      for (int i = 0; i < numberOfFolds; ++i) {
+        int p = i; // avoid "access to modified closure" warning below
+        var trainingRows = folds.SelectMany((par, j) => j != p ? par : Enumerable.Empty<int>());
+        var testRows = folds[i];
+        var trainingSvmProblem = CreateSvmProblem(problemData.Dataset, targetVariable, problemData.AllowedInputVariables, trainingRows);
+        var rangeTransform = RangeTransform.Compute(trainingSvmProblem);
+        var testSvmProblem = rangeTransform.Scale(CreateSvmProblem(problemData.Dataset, targetVariable, problemData.AllowedInputVariables, testRows));
+        partitions[i] = new Tuple<svm_problem, svm_problem>(rangeTransform.Scale(trainingSvmProblem), testSvmProblem);
+      }
+      return partitions;
+    }
+
+    public static IEnumerable<IEnumerable<int>> GenerateFolds(IDataAnalysisProblemData problemData, int numberOfFolds, bool shuffleFolds = true) {
+      var random = new MersenneTwister((uint)Environment.TickCount);
+      if (problemData is IRegressionProblemData) {
+        var trainingIndices = shuffleFolds ? problemData.TrainingIndices.OrderBy(x => random.Next()) : problemData.TrainingIndices;
+        return GenerateFolds(trainingIndices, problemData.TrainingPartition.Size, numberOfFolds);
+      }
+      if (problemData is IClassificationProblemData) {
+        // when shuffle is enabled do stratified folds generation, some folds may have zero elements 
+        // otherwise, generate folds normally
+        return shuffleFolds ? GenerateFoldsStratified(problemData as IClassificationProblemData, numberOfFolds, random) : GenerateFolds(problemData.TrainingIndices, problemData.TrainingPartition.Size, numberOfFolds);
+      }
+      throw new ArgumentException("Problem data is neither regression or classification problem data.");
+    }
+
+    /// <summary>
+    /// Stratified fold generation from classification data. Stratification means that we ensure the same distribution of class labels for each fold.
+    /// The samples are grouped by class label and each group is split into @numberOfFolds parts. The final folds are formed from the joining of 
+    /// the corresponding parts from each class label.
+    /// </summary>
+    /// <param name="problemData">The classification problem data.</param>
+    /// <param name="numberOfFolds">The number of folds in which to split the data.</param>
+    /// <param name="random">The random generator used to shuffle the folds.</param>
+    /// <returns>An enumerable sequece of folds, where a fold is represented by a sequence of row indices.</returns>
+    private static IEnumerable<IEnumerable<int>> GenerateFoldsStratified(IClassificationProblemData problemData, int numberOfFolds, IRandom random) {
+      var values = problemData.Dataset.GetDoubleValues(problemData.TargetVariable, problemData.TrainingIndices);
+      var valuesIndices = problemData.TrainingIndices.Zip(values, (i, v) => new { Index = i, Value = v }).ToList();
+      IEnumerable<IEnumerable<IEnumerable<int>>> foldsByClass = valuesIndices.GroupBy(x => x.Value, x => x.Index).Select(g => GenerateFolds(g, g.Count(), numberOfFolds));
+      var enumerators = foldsByClass.Select(f => f.GetEnumerator()).ToList();
+      while (enumerators.All(e => e.MoveNext())) {
+        yield return enumerators.SelectMany(e => e.Current).OrderBy(x => random.Next()).ToList();
+      }
+    }
+
+    private static IEnumerable<IEnumerable<T>> GenerateFolds<T>(IEnumerable<T> values, int valuesCount, int numberOfFolds) {
+      // if number of folds is greater than the number of values, some empty folds will be returned
+      if (valuesCount < numberOfFolds) {
+        for (int i = 0; i < numberOfFolds; ++i)
+          yield return i < valuesCount ? values.Skip(i).Take(1) : Enumerable.Empty<T>();
+      } else {
+        int f = valuesCount / numberOfFolds, r = valuesCount % numberOfFolds; // number of folds rounded to integer and remainder
+        int start = 0, end = f;
+        for (int i = 0; i < numberOfFolds; ++i) {
+          if (r > 0) {
+            ++end;
+            --r;
+          }
+          yield return values.Skip(start).Take(end - start);
+          start = end;
+          end += f;
+        }
+      }
+    }
+
+    private static Action<svm_parameter, double> GenerateSetter(string fieldName) {
+      var targetExp = Expression.Parameter(typeof(svm_parameter));
+      var valueExp = Expression.Parameter(typeof(double));
+      var fieldExp = Expression.Field(targetExp, fieldName);
+      var assignExp = Expression.Assign(fieldExp, Expression.Convert(valueExp, fieldExp.Type));
+      var setter = Expression.Lambda<Action<svm_parameter, double>>(assignExp, targetExp, valueExp).Compile();
+      return setter;
+    }
+
+    private static string GetTargetVariableName(IDataAnalysisProblemData problemData) {
+      var regressionProblemData = problemData as IRegressionProblemData;
+      var classificationProblemData = problemData as IClassificationProblemData;
+
+      if (regressionProblemData != null)
+        return regressionProblemData.TargetVariable;
+      if (classificationProblemData != null)
+        return classificationProblemData.TargetVariable;
+
+      throw new ArgumentException("Problem data is neither regression or classification problem data.");
     }
   }
Index: /stable/HeuristicLab.CodeEditor/3.3/CodeEditor.Designer.cs
===================================================================
--- /stable/HeuristicLab.CodeEditor/3.3/CodeEditor.Designer.cs	(revision 11906)
+++ /stable/HeuristicLab.CodeEditor/3.3/CodeEditor.Designer.cs	(revision 11907)
@@ -46,11 +46,12 @@
       // textEditor
       // 
-      this.textEditor.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.textEditor.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.textEditor.ConvertTabsToSpaces = true;
       this.textEditor.IndentStyle = ICSharpCode.TextEditor.Document.IndentStyle.Auto;
       this.textEditor.IsIconBarVisible = true;
       this.textEditor.IsReadOnly = false;
+      this.textEditor.LineViewerStyle = ICSharpCode.TextEditor.Document.LineViewerStyle.FullRow;
       this.textEditor.Location = new System.Drawing.Point(0, 0);
       this.textEditor.Name = "textEditor";
@@ -97,5 +98,5 @@
       this.sharpDevelopLabel.Text = "powered by #develop";
       this.sharpDevelopLabel.ToolTipText = "Syntax highlighting and code completion facilities provided through #develop libr" +
-          "aries";
+    "aries";
       this.sharpDevelopLabel.Click += new System.EventHandler(this.toolStripStatusLabel1_Click);
       // 
@@ -108,5 +109,4 @@
       // CodeEditor
       // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.Controls.Add(this.textEditor);
Index: /stable/HeuristicLab.CodeEditor/3.3/CodeEditor.cs
===================================================================
--- /stable/HeuristicLab.CodeEditor/3.3/CodeEditor.cs	(revision 11906)
+++ /stable/HeuristicLab.CodeEditor/3.3/CodeEditor.cs	(revision 11907)
@@ -46,4 +46,6 @@
 
     #region Fields & Properties
+    private static Color WarningColor = Color.Blue;
+    private static Color ErrorColor = Color.Red;
 
     internal Dom.ProjectContentRegistry projectContentRegistry;
@@ -127,4 +129,5 @@
       }
       set {
+        if (Doc.TextContent == value) return;
         Doc.Replace(prefix.Length, Doc.TextLength - suffix.Length - prefix.Length, value);
         Doc.RequestUpdate(new TextAreaUpdate(TextAreaUpdateType.WholeTextArea));
@@ -133,8 +136,12 @@
     }
 
+    public bool ReadOnly {
+      get { return Doc.ReadOnly; }
+      set { Doc.ReadOnly = value; }
+    }
+
     #endregion
 
     public event EventHandler TextEditorValidated;
-
     protected void OnTextEditorValidated() {
       if (TextEditorValidated != null)
@@ -143,5 +150,4 @@
 
     public event EventHandler TextEditorTextChanged;
-
     protected void OnTextEditorTextChanged() {
       if (TextEditorTextChanged != null)
@@ -154,7 +160,5 @@
       textEditor.ActiveTextAreaControl.TextEditorProperties.SupportReadOnlySegments = true;
 
-      textEditor.SetHighlighting("C#");
-      textEditor.ShowEOLMarkers = false;
-      textEditor.ShowInvalidLines = false;
+      LoadHighlightingStrategy();
       HostCallbackImplementation.Register(this);
       CodeCompletionKeyHandler.Attach(this, textEditor);
@@ -187,14 +191,25 @@
         return;
 
-      textEditor.ActiveTextAreaControl.TextArea.KeyEventHandler += new ICSharpCode.TextEditor.KeyEventHandler(TextArea_KeyEventHandler);
-      textEditor.ActiveTextAreaControl.TextArea.DoProcessDialogKey += new DialogKeyProcessor(TextArea_DoProcessDialogKey);
-
-      parserThread = new Thread(ParserThread);
-      parserThread.IsBackground = true;
+      textEditor.ActiveTextAreaControl.TextArea.KeyEventHandler += TextArea_KeyEventHandler;
+      textEditor.ActiveTextAreaControl.TextArea.DoProcessDialogKey += TextArea_DoProcessDialogKey;
+
+      parserThread = new Thread(ParserThread) { IsBackground = true };
       parserThread.Start();
 
-      textEditor.Validated += (s, a) => { OnTextEditorValidated(); };
-      textEditor.TextChanged += (s, a) => { OnTextEditorTextChanged(); };
+      textEditor.Validated += (s, a) => OnTextEditorValidated();
+      textEditor.TextChanged += (s, a) => {
+        Doc.MarkerStrategy.RemoveAll(m => errorMarkers.Contains(m)); errorMarkers.Clear();
+        Doc.BookmarkManager.RemoveMarks(m => errorBookmarks.Contains(m)); errorBookmarks.Clear();
+        Doc.RequestUpdate(new TextAreaUpdate(TextAreaUpdateType.WholeTextArea));
+        Doc.CommitUpdate();
+        OnTextEditorTextChanged();
+      };
       InitializeImageList();
+    }
+
+    private void LoadHighlightingStrategy() {
+      var strategy = (DefaultHighlightingStrategy)HighlightingManager.Manager.FindHighlighter("C#");
+      strategy.SetColorFor("CaretMarker", new HighlightColor(Color.Beige, false, false));
+      Doc.HighlightingStrategy = strategy;
     }
 
@@ -211,5 +226,4 @@
 
     #region keyboard handlers: filter input in read-only areas
-
     bool TextArea_KeyEventHandler(char ch) {
       int caret = textEditor.ActiveTextAreaControl.Caret.Offset;
@@ -227,5 +241,4 @@
       return false;
     }
-
     #endregion
 
@@ -235,11 +248,15 @@
     }
 
+    public void ScrollToPosition(int line, int column) {
+      var segment = GetSegmentAtOffset(line, column);
+      var position = Doc.OffsetToPosition(segment.Offset + segment.Length);
+      var caret = textEditor.ActiveTextAreaControl.Caret;
+      caret.Position = position;
+      textEditor.ActiveTextAreaControl.CenterViewOn(line, 0);
+    }
+
     private List<TextMarker> errorMarkers = new List<TextMarker>();
     private List<Bookmark> errorBookmarks = new List<Bookmark>();
     public void ShowCompileErrors(CompilerErrorCollection compilerErrors, string filename) {
-      Doc.MarkerStrategy.RemoveAll(m => errorMarkers.Contains(m));
-      Doc.BookmarkManager.RemoveMarks(m => errorBookmarks.Contains(m));
-      errorMarkers.Clear();
-      errorBookmarks.Clear();
       errorLabel.Text = "";
       errorLabel.ToolTipText = null;
@@ -268,5 +285,5 @@
     private void AddErrorMarker(CompilerError error) {
       var segment = GetSegmentAtOffset(error.Line, error.Column);
-      Color color = error.IsWarning ? Color.Blue : Color.Red;
+      Color color = error.IsWarning ? WarningColor : ErrorColor;
       var marker = new TextMarker(segment.Offset, segment.Length, TextMarkerType.WaveLine, color) {
         ToolTip = error.ErrorText,
@@ -277,5 +294,6 @@
 
     private void AddErrorBookmark(CompilerError error) {
-      var bookmark = new ErrorBookmark(Doc, new TextLocation(error.Column, error.Line - 1));
+      Color color = error.IsWarning ? WarningColor : ErrorColor;
+      var bookmark = new ErrorBookmark(Doc, new TextLocation(error.Column, error.Line - 1), color);
       errorBookmarks.Add(bookmark);
       Doc.BookmarkManager.AddMark(bookmark);
@@ -283,8 +301,8 @@
 
     private AbstractSegment GetSegmentAtOffset(int lineNr, int columnNr) {
-      lineNr = Math.Max(Doc.OffsetToPosition(prefix.Length).Line, lineNr);
+      lineNr = Math.Max(Doc.OffsetToPosition(prefix.Length).Line, lineNr - 1);
       lineNr = Math.Min(Doc.OffsetToPosition(Doc.TextLength - suffix.Length).Line, lineNr);
-      var line = Doc.GetLineSegment(lineNr - 1);
-      columnNr = Math.Max(0, columnNr);
+      var line = Doc.GetLineSegment(lineNr);
+      columnNr = Math.Max(0, columnNr - 1);
       columnNr = Math.Min(line.Length, columnNr);
       var word = line.GetWord(columnNr);
@@ -294,5 +312,5 @@
         segment.Length = word.Length;
       } else {
-        segment.Offset = line.Offset + columnNr - 1;
+        segment.Offset = line.Offset + columnNr;
         segment.Length = 1;
       }
Index: /stable/HeuristicLab.CodeEditor/3.3/ErrorBookmark.cs
===================================================================
--- /stable/HeuristicLab.CodeEditor/3.3/ErrorBookmark.cs	(revision 11906)
+++ /stable/HeuristicLab.CodeEditor/3.3/ErrorBookmark.cs	(revision 11907)
@@ -25,12 +25,17 @@
 namespace HeuristicLab.CodeEditor {
   public class ErrorBookmark : Bookmark {
+    private readonly Brush brush;
 
     public override bool CanToggle { get { return false; } }
 
     public ErrorBookmark(IDocument document, TextLocation location)
+      : this(document, location, Color.Red) { }
+
+    public ErrorBookmark(IDocument document, TextLocation location, Color color)
       : base(document, location) {
+      brush = new SolidBrush(color);
     }
 
-    public override void Draw(IconBarMargin margin, System.Drawing.Graphics g, System.Drawing.Point p) {
+    public override void Draw(IconBarMargin margin, Graphics g, Point p) {
       int delta = margin.TextArea.TextView.FontHeight / 4;
       Rectangle rect = new Rectangle(
@@ -39,5 +44,5 @@
         margin.DrawingPosition.Width - 6,
         margin.TextArea.TextView.FontHeight - delta * 2);
-      g.FillRectangle(Brushes.Red, rect);
+      g.FillRectangle(brush, rect);
       g.DrawRectangle(Pens.White, rect);
     }
Index: /stable/HeuristicLab.CodeEditor/3.3/HeuristicLab.CodeEditor-3.3.csproj
===================================================================
--- /stable/HeuristicLab.CodeEditor/3.3/HeuristicLab.CodeEditor-3.3.csproj	(revision 11906)
+++ /stable/HeuristicLab.CodeEditor/3.3/HeuristicLab.CodeEditor-3.3.csproj	(revision 11907)
@@ -145,7 +145,4 @@
   <ItemGroup>
     <Compile Include="CodeCompletionData.cs" />
-    <EmbeddedResource Include="CodeEditor.resx">
-      <DependentUpon>CodeEditor.cs</DependentUpon>
-    </EmbeddedResource>
     <EmbeddedResource Include="CodeViewer.resx">
       <DependentUpon>CodeViewer.cs</DependentUpon>
Index: /stable/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj
===================================================================
--- /stable/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 11906)
+++ /stable/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 11907)
@@ -135,4 +135,8 @@
     <EmbeddedResource Include="Documents\GP_Multiplexer.hl" />
     <EmbeddedResource Include="Documents\OSGP_TimeSeries.hl" />
+    <EmbeddedResource Include="Documents\GridSearch_RF_Classification_Script.hl" />
+    <EmbeddedResource Include="Documents\GridSearch_RF_Regression_Script.hl" />
+    <EmbeddedResource Include="Documents\GridSearch_SVM_Classification_Script.hl" />
+    <EmbeddedResource Include="Documents\GridSearch_SVM_Regression_Script.hl" />
     <None Include="Plugin.cs.frame" />
     <Compile Include="OptimizerSingleDocumentMainForm.cs">
Index: /stable/HeuristicLab.Optimizer/3.3/StartPage.cs
===================================================================
--- /stable/HeuristicLab.Optimizer/3.3/StartPage.cs	(revision 11906)
+++ /stable/HeuristicLab.Optimizer/3.3/StartPage.cs	(revision 11907)
@@ -145,6 +145,6 @@
       groupLookup[dataAnalysisGroup] = dataAnalysisProblems;
       var scripts = new List<string> { "GA_QAP_Script", "GUI_Automation_Script", "OSGA_Rastrigin_Script", 
-                                       "GridSearch_RF_Classification", "GridSearch_RF_Regression",
-                                       "GridSearch_SVM_Classification", "GridSearch_SVM_Regression" };
+                                       "GridSearch_RF_Classification_Script", "GridSearch_RF_Regression_Script",
+                                       "GridSearch_SVM_Classification_Script", "GridSearch_SVM_Regression_Script" };
       groupLookup[scriptsGroup] = scripts;
     }
Index: /stable/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.cs
===================================================================
--- /stable/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.cs	(revision 11906)
+++ /stable/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.cs	(revision 11907)
@@ -111,5 +111,5 @@
         if (Compile()) {
           outputTextBox.Clear();
-          Content.Execute();
+          Content.ExecuteAsync();
           Running = true;
         }
@@ -123,5 +123,5 @@
             if (Compile()) {
               outputTextBox.Clear();
-              Content.Execute();
+              Content.ExecuteAsync();
               Running = true;
             }
@@ -132,8 +132,8 @@
           return true;
         case Keys.F6:
-          if (!Running) Compile();
+          if (!Running) base.ProcessCmdKey(ref msg, keyData);
           return true;
       }
-      return base.ProcessCmdKey(ref msg, keyData); ;
+      return base.ProcessCmdKey(ref msg, keyData);
     }
     #endregion
Index: /stable/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs
===================================================================
--- /stable/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs	(revision 11906)
+++ /stable/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs	(revision 11907)
@@ -110,5 +110,5 @@
       this.toolTip.SetToolTip(this.compileButton, "Compile (F6)");
       this.compileButton.UseVisualStyleBackColor = true;
-      this.compileButton.Click += new System.EventHandler(this.CompileButtonOnClick);
+      this.compileButton.Click += new System.EventHandler(this.compileButton_Click);
       // 
       // infoTabControl
@@ -178,4 +178,5 @@
       this.errorListView.UseCompatibleStateImageBehavior = false;
       this.errorListView.View = System.Windows.Forms.View.Details;
+      this.errorListView.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(this.errorListView_MouseDoubleClick);
       // 
       // iconColumnHeader
@@ -213,10 +214,10 @@
       this.codeEditor.TabIndex = 0;
       this.codeEditor.UserCode = "";
-      this.codeEditor.TextEditorTextChanged += new System.EventHandler(this.CodeEditorOnTextEditorTextChanged);
+      this.codeEditor.TextEditorTextChanged += new System.EventHandler(this.codeEditor_TextEditorTextChanged);
       // 
       // splitContainer1
       // 
-      this.splitContainer1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.splitContainer1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.splitContainer1.Location = new System.Drawing.Point(0, 56);
